



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>sqlserver—数据完整性（理论篇）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">sqlserver—数据完整性（理论篇）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 18:56:16 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<ul><li>数据完整性主要指的是数据的精确性和可靠性，目的就是为了防止数据库中存放的数值，以及字符具有合法性（即按照管理员定义的规则进行存放）</li></ul>
<p>分为以下四类：</p>
<ol><li><strong>实体完整性</strong></li></ol>
<p>实体完整性要求每一个表中的主键字段都不能为空或者重复的值。实体完整性指表中行的完整性。要求表中的所有行都有唯一的标识符，称为主关键字。主关键字是否可以修改，或整个列是否可以被删除，取决于主关键字与其他表之间要求的完整性。</p>
<p><strong>&nbsp; 实体完整性规则：</strong><br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 基本关系的所有主关键字对应的主属性都不能取空值，例如，学生选课的关系选课（学号，课程号，成绩）中，学号和课程号共同组成为主关键字，则学号和课程号两个属性都不能为空。因为没有学号的成绩或没有课程号的成绩都是不存在的。</p>
<blockquote><p>候选键：<strong>唯一，允许不填</strong></p>
<p>主键： <strong>唯一，必填，排序 每个表只能有一个主键。</strong></p>
<p>自增长：<strong>必须是数字。系统自动增长的。</strong></p>
<p>默认值：<strong>如果不填就用默认值填充，如果填了就用填写的值保存。</strong></p>
<p>非空约束：<strong>不能不填。</strong></p></blockquote>
<p><strong>2.域完整性</strong></p>
<p><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; </strong>域完整性可以强制域完整性限制类型（即通过使用数据类型）、限制格式（即通过使用check约束和规则）或者是限制可能值得范围（使用foreign key约束、check约束、default定义、not null定义和规则）。</p>
<p><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 3.引用完整性</strong></p>
<p>该名词，很多同志可能刚看到也比较陌生，因为在SQL server2000之前（不含）的版本中一直被包括在参照完整性的概念里。</p>
<p>在输入或删除记录时，引用完整性保持表之间已定义的关系。在 Microsoft&reg; SQL Server&trade; 2000 中，引用完整性基于外键与主键之间或外键与唯一键之间的关系（通过 FOREIGN KEY 和 CHECK 约束）。引用完整性确保键值在所有表中一致。这样的一致性要求不能引用不存在的值，如果键值更改了，那么在整个数据库中，对该键值的所有引用要进行一致的更改。<br />强制引用完整性时，SQL Server 禁止用户进行下列操作：</p>
<ul><li>当主表中没有关联的记录时，将记录添加到相关表中。</li>
<li>更改主表中的值并导致相关表中的记录孤立。</li>
<li>从主表中删除记录，但仍存在与该记录匹配的相关记录。 <br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 例如，对于 pubs 数据库中的 sales 和 titles 表，引用完整性基于 sales 表中的键 (title_id) 与 titles 表中的主键 (title_id) 之间的关系。</li></ul>
<p>4.用户定义完整性</p>
<p>用户定义完整性使您得以定义不属于其它任何完整性分类的特定业务规则。所有的完整性类型都支持用户定义完整性（CREATE TABLE 中的所有列级和表级约束、存储过程和触发器）。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/wq15y09g.html">Spring aop应用之实现数据库读写分离</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j0m5gq.html">Django模板的继承</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p2gn48.html">ROS 常用命令字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxgx1j9.html">微信的redirect&lowbar;uri参数错误原因分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnn0ge8.html">6&period;1&period;1Linux下Socket编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnwvy0q.html">ibaits与spring整合的心得</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdyo038.html">http 协议的过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j05vnlq.html">angularjs&colon;&lbrack;1&rsqb; ui-router 权限控制</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o13749.html">RMAN备份之丢失数据文件及控制文件的恢复</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge123z8.html">Codeforces Round &num;189 &lpar;Div&period; 2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/950znrz8.html">201521123037 《Java程序设计》第3周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zwzjn9.html">JavaScript 数组对象的去重</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjrrzg8.html">delphi idhttp post 普通提交乱码处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwyvp79.html">（二）使用数组长度实现ADT bag（java）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvw55dq.html">day67</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vkm56q.html">【BZOJ-4212】神牛的养成计划       Trie树 &plus; 可持久化Trie树</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv1pljq.html">获取和设置URL里星号&lpar;&num;&rpar;的参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx212108.html">VK Cup 2015 - Round 1 E&period; Rooks and Rectangles 线段树 定点修改，区间最小值</a>
		</li>
						<li><a href="https://www.batexi.com/a/q77l051q.html">32、Flask实战第32天：优化json数据的返回</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e0z45mq.html">《Effective C&plus;&plus;》学习笔记（一）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pdolod9.html">加密原理介绍，代码实现DES、AES、RSA、Base64、MD5</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k61159.html">PAT1105&colon;Spiral Matrix</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjm1lk8.html">MySQL InnoDB独立表空间模式的优点和缺点介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/950k4k68.html">Java 8 Optional类深度解析（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zy4119.html">Linux共享库、静态库、动态库详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zy4rk9.html">数据结构 之 并查集（Disjoint Set）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zveke9.html">Circular view path &lbrack;home&rsqb;&colon; would dispatch back to the current handler URL &lbrack;&sol;home&rsqb; again&period; Check your ViewResolver setup&excl;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me7ozoq.html">spring-boot-oracle spring-batch</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zozgo1q.html">sql server按符号截取字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/950ermz8.html">python实现邮件的发送</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
